<script setup>
import { onBeforeMount } from 'vue'
import { useRoute } from 'vue-router'
import router from '@/router';
import { useInstrumentStore } from '../stores/instrument.js'
import { CdxIcon, CdxButton } from '@wikimedia/codex';
import { cdxIconEdit } from '@wikimedia/codex-icons';
import useUtility from '../composables/utility.js'

// UI stuff
import { useCookies} from 'vue3-cookies';

const { cookies } = useCookies();
const store = useInstrumentStore();

const { parseSampleRate } = useUtility();

const route = useRoute()

onBeforeMount(() => {
    store.setInstrument(route.params.slug)
})

function onClick() {
    const routePath = store.instrument.type === 'A/B test' ? 'update-experiment' : 'update-instrument';
    router.push({ name: routePath, params: { slug: route.params.slug } })
}
</script>

<template>
    <Suspense>
        <div class="read-view">
            <!-- HEADER -->
            <div class="subheader">
                <div class="left">
                    <h1 class="title">{{ store.instrument.name }}</h1>
                </div>
                <div class="right">
                    <!-- Always show 'Edit' regardless of instrument type -->
                     <cdx-button action="default" weight="quiet" @click="onClick">
                        <cdx-icon :icon="cdxIconEdit" /> 
                        Edit
                     </cdx-button>
                </div>
            </div>
            <div class="subtitle">Machine Readable Name</div>
            <div class="body">{{ store.instrument.slug }}</div>

            <div class="subtitle">Instrument Description</div>
            <div class="body" data-id="description">{{ store.instrument.description }}</div>

            <div class="subtitle">Phabricator Ticket</div>
            <div class="body" data-id="task">
                <a class="cdx-docs-link" target="_blank" :href="`${store.instrument.task}`">
                    {{ store.instrument.task.substring(store.instrument.task.lastIndexOf('/') + 1) }}
                </a>
            </div>

            <div class="subtitle">Team</div>
            <div class="body">{{ store.instrument.owner.join(', ') }}</div>

            <div class="subtitle">Contact</div>
            <div class="body" data-id="email">
                <a class="cdx-docs-link" :href="`mailto:${store.instrument.email_address}`">
                    {{ store.instrument.email_address }}
                </a>
            </div>

            <div class="subtitle">Purpose</div>
            <div class="body">{{ store.instrument.purpose.join(', ') }}</div>

            <span v-if="!(store.isABTest)">
                <div class="subtitle">Contextual Attributes</div>
                <div class="body" data-id="contextual-attributes">
                    {{ store.instrument.contextual_attributes }}
                </div>
            </span>

            <div class="subtitle">Instrument Type</div>
            <div class="body">{{ store.instrument.type }}</div>

            <div class="subtitle">Sampling</div>
            <div class="body" v-html="parseSampleRate(store.instrument.sample_rate)"></div>

            <div class="subtitle">Sample Unit</div>
            <div class="body" data-id="sample-unit">{{ store.instrument.sample_unit }}</div>

            <span v-if="store.isABTest">
                <div class="subtitle">Feature variants</div>
                <div class="body">
                    <div>Feature Name: {{ store.instrument.variants[0].name }}</div>
                    <div>Variant Type: {{ store.instrument.variants[0].type }}</div>
                    <div>Variant Control: {{ store.experimentFeatureControl }}</div>
                    <div>Variant Values: {{ store.instrument.variants[0].values }}</div>
                </div>
            </span>
            <span v-else>
                <div class="subtitle">Stream name and Schema details</div>
                <div class="body">
                    <div>Stream Name: {{ store.instrument.stream_name }}</div>
                    <div>Schema Type: {{ store.instrument.schema_type }}</div>
                    <div>Schema Title: {{ store.instrument.schema_title }}</div>  
                </div>
            </span>

            <div class="subtitle">Duration</div>
            <div class="body">
                <div>Progress: {{ Math.round(store.instrument.progress * 100) + ' %'}}</div>
                <div>Start Date: {{ store.instrument.utc_start_dt }}</div>
                <div>End Date: {{ store.instrument.utc_end_dt }}</div>
            </div>

            <div class="subtitle">Security and Legal</div>
            <div class="body" data-id="security-legal-review">{{ store.instrument.security_legal_review }}</div>

            <div class="subtitle">Compliance Requirements</div>
            <div class="body" data-id="compliance-requirements">{{ store.instrument.compliance_requirements }}</div>
        </div>

        <template #fallback>
            <div>Loading...</div>
        </template>
    </Suspense>

</template>

<style scoped>
@import '@wikimedia/codex-design-tokens/theme-wikimedia-ui.css';

.subheader {
    display: flex;
    justify-content: space-between;
    border-bottom: 1px solid #A2A9B1;
}

.title {
    border: none;
}

.left,
.right {
    display: flex;
    align-items: center;
}

.subtitle {
    padding: 20px 0 25px;
    font-weight: bold;
}

.read-view {
    margin-bottom: 30px;
}
</style>
